About This Guide
-----------------

The instructions in this guide are for registered Workshop users
only.

By [registering](https://swarm.workshop.perforce.com/signup), you
can contribute to, comment on, or just follow your favorite
projects.

A registered account is not necessary to [browse](browsing.md)
the Workshop.

This guide assumes that the reader is already familiar with the
basics of Perforce usage. If you are a new Perforce user, we
recommend reading the following documentation to get started:

-   [Introducing
    Perforce (PDF)](http://www.perforce.com/perforce/doc.current/manuals/intro/intro.pdf) -
    Introductory guide to Perforce concepts
-   [Getting Started with
    P4V (PDF)](http://www.perforce.com/perforce/doc.current/manuals/p4v-gs/p4v-gs.pdf) -
    Introductory guide to P4V, our cross-platform GUI
-   [P4 User's
    Guide](http://www.perforce.com/perforce/doc.current/manuals/p4guide/index.html) -
    Detailed guide to the P4 command-line client.

Perforce client software is freely available on our
[downloads page](http://www.perforce.com/downloads).

Contributing to the Workshop
----------------------------

### Setting Up

-   Connect to **public.perforce.com:1666** in your Perforce client,
    using the user name and password you received when you registered.
-   Create a workspace that maps your guest branch path, which will be
    **//guest/user name/...**.
-   You have **read** access to the entire depot, but only your guest
    branch is writable (and only to you).

### Working on Projects

-   If you're contributing a new project, add your project files to a
    subdirectory under your guest branch.
-   If you want to make modifications to an existing project, branch the
    files into a subdirectory under your guest branch.
-   Make any edits in your guest branch that you like.
-   If you're modifying someone else's project, remember to preserve any
    applicable license notices.

### Sharing Development

-   If you want to share edits you've made to someone else's project,
    let them know by emailing or shelving a change for [review](https://www.perforce.com/resources/tutorials/create-swarm-review).
-   If you want to incorporate someone else's edits into your project,
    just **p4 integrate** from their guest branch to yours, following
    any license restrictions.

Contributing documentation
------------------------

-   Every project, big or small, can and should have a project page. It
    is very easy to create a project page and they make it much easier
    for people to find the tools you have created.
-   If you aren't already familiar with Markdown, see
    [the official documentation](http://daringfireball.net/projects/markdown/).


### Creating Project Pages

-   Simply submit a file named `README.md` to your main branch.

-   Your project page can contain any information you think will be
    useful to other users.

-   Remember to keep your project page updated. Over time, you may wish
    to add more detail, announce new features, et cetera.

-   You are responsible for verifying the accuracy and appropriateness
    of any content you submit.

-   Do not submit copyrighted work without permission.
